#ifndef LIBR2C2_ARTICLENUMBER_H_
#define LIBR2C2_ARTICLENUMBER_H_

#include <string>
#include <vector>
#include <msp/datafile/objectloader.h>
#include <msp/strings/lexicalcast.h>

namespace R2C2 {

class ArticleNumber
{
public:
	class Loader: public Msp::DataFile::ObjectLoader<ArticleNumber>
	{
	public:
		Loader(ArticleNumber &);
	};

private:
	std::string vendor;
	std::string article;
	std::string part;

public:
	ArticleNumber() { }
	ArticleNumber(const std::string &);
	ArticleNumber(const std::string &, const std::string &, const std::string & = std::string());

	const std::string &get_vendor() const { return vendor; }
	const std::string &get_article() const { return article; }
	const std::string &get_part() const { return part; }
	std::string str() const;
};

void operator<<(Msp::LexicalConverter &, const ArticleNumber &);

} // namespace R2C2

#endif
