#ifndef LIBR2C2_TRAINSTATUS_H_
#define LIBR2C2_TRAINSTATUS_H_

#include <string>
#include <sigc++/signal.h>
#include "trainai.h"

namespace R2C2 {

class Train;

/**
Provides textual description of the status of a train.
*/
class TrainStatus: public TrainAI
{
public:
	sigc::signal<void, const std::string &> signal_changed;

private:
	int speed;
	std::string status;

public:
	TrainStatus(Train &);

	const std::string &get_status() const { return status; }
	void tick(const Msp::Time::TimeDelta &);
private:
	void check();
};

} // namespace R2C2

#endif
