#ifndef MAINPANEL_H_
#define MAINPANEL_H_

#include <gtkmm/box.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/label.h>
#include "network/client.h"

class Remote;

class MainPanel: public Gtk::VBox
{
private:
	Remote &remote;
	R2C2::Client &client;
	Gtk::CheckButton *chk_power;
	Gtk::CheckButton *chk_halt;
	Gtk::Label *lbl_status;

public:
	MainPanel(Remote &, R2C2::Client &);

private:
	void power_changed(bool);
	void halt_changed(bool);
	void emergency(const std::string &);
	void ui_power_changed();
	void ui_halt_changed();
};

#endif
