#ifndef SERIAL_H_
#define SERIAL_H_

#include <msp/core/application.h>
#include <msp/io/serial.h>
#include "network/client.h"

class Serial: public Msp::RegisteredApplication<Serial>
{
private:
	Msp::IO::EventDispatcher event_disp;
	R2C2::Catalogue catalogue;
	R2C2::Client client;
	Msp::IO::Serial serial_port;
	R2C2::NetTrain *train;
	bool reverse;
	char rx_buf[3];
	unsigned rx_fill;

public:
	Serial(int, char **);

private:
	virtual void tick();
	void train_added(R2C2::NetTrain &);
	void error(const std::string &);
	void set_train(R2C2::NetTrain *);
	void next_train();
	void prev_train();
	void data_available();
};

#endif
